'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d = require('d3');

var d3 = _interopRequireWildcard(_d);

var _simulation = require('./simulation');

var _simulation2 = _interopRequireDefault(_simulation);

var _node = require('./node');

var _node2 = _interopRequireDefault(_node);

var _link = require('./link');

var _link2 = _interopRequireDefault(_link);

var _layout2 = require('./layout');

var _layout3 = _interopRequireDefault(_layout2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _default = require('./default');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var duration = 500;

var D3ReactForce = (_temp = _class = function (_React$Component) {
  (0, _inherits3.default)(D3ReactForce, _React$Component);

  function D3ReactForce(props) {
    (0, _classCallCheck3.default)(this, D3ReactForce);

    var _this = (0, _possibleConstructorReturn3.default)(this, (D3ReactForce.__proto__ || (0, _getPrototypeOf2.default)(D3ReactForce)).call(this, props));

    _initialiseProps.call(_this);

    var nodes = props.nodes,
        links = props.links,
        staticLayout = props.staticLayout;

    _this.nodesDom = {};
    _this.linksDom = {};
    _this.hoverLinksDom = {};
    _this.force = new _simulation2.default(props);
    _this.force.setNodesLinks(nodes, links);
    _this.state = {
      init: false
    };
    return _this;
  }

  (0, _createClass3.default)(D3ReactForce, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.props.staticLayout) {
        var _props = this.props,
            _props$dragEvent = _props.dragEvent,
            dragEvent = _props$dragEvent === undefined ? {} : _props$dragEvent,
            _props$zoomEvent = _props.zoomEvent,
            zoomEvent = _props$zoomEvent === undefined ? {} : _props$zoomEvent,
            scaleExtent = _props.scaleExtent;

        this.force.initZoom({
          start: zoomEvent.start,
          isZoom: zoomEvent.isZoom,
          zoom: function zoom(transform) {
            d3.select(_this2.outg).attr('transform', 'translate(' + transform.translate + ')scale(' + transform.scale + ')');
            zoomEvent.zoom && zoomEvent.zoom(transform);
          },
          end: zoomEvent.end
        }, scaleExtent);
        d3.select(this.svg).call(this.force.zoom).on('dblclick.zoom', null);
        this.force.initDrag(dragEvent);
      }
      this.force.tick({
        tick: this.tick,
        end: this.props.end
      });
      this.setState({ init: true }); // 解决初始化有nodes时 node先渲染，取不到this.drap问题
    }

    // 居中

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nodes = nextProps.nodes,
          links = nextProps.links;

      this.force.setSimulationLayout(nextProps);
      this.force.setNodesLinks(nodes, links);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          width = _props2.width,
          height = _props2.height,
          nodeIdKey = _props2.nodeIdKey,
          staticLayout = _props2.staticLayout,
          svgProps = _props2.svgProps,
          outgProps = _props2.outgProps;
      var _force = this.force,
          translate = _force.translate,
          scale = _force.scale,
          nodes = _force.nodes,
          links = _force.links,
          drag = _force.drag;

      var staticLayoutTransform = {};
      if (staticLayout) {
        var getStaticLayoutTransform = this.getStaticLayoutTransform();
        width = getStaticLayoutTransform.width;
        height = getStaticLayoutTransform.height;
        translate = getStaticLayoutTransform.translate;
        scale = getStaticLayoutTransform.scale;
      }
      return _react2.default.createElement(
        'svg',
        (0, _extends3.default)({ xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', ref: function ref(svg) {
            return _this3.svg = svg;
          }, width: width, height: height }, svgProps),
        _react2.default.createElement(
          'g',
          (0, _extends3.default)({ ref: function ref(outg) {
              return _this3.outg = outg;
            }, transform: 'translate(' + translate + ')scale(' + scale + ')' }, outgProps),
          this.state.init || staticLayout ? [_react2.default.createElement(
            'g',
            { key: 'nodes' },
            links.map(function (link, i) {
              var _key_ = link.source[nodeIdKey] + '_' + link.target[nodeIdKey];
              return _react2.default.createElement(_link2.default, { key: _key_, parentComponment: _this3, addRef: function addRef(c) {
                  _this3.linksDom[_key_] = c;
                }, addHoverRef: function addHoverRef(c) {
                  _this3.hoverLinksDom[_key_] = c;
                }, link: link });
            })
          ), _react2.default.createElement(
            'g',
            { key: 'links' },
            nodes.map(function (node, i) {
              var _key_ = node[nodeIdKey];
              return _react2.default.createElement(_node2.default, { key: _key_, parentComponment: _this3, addRef: function addRef(c) {
                  _this3.nodesDom[_key_] = c;
                }, node: node });
            })
          )] : null,
          this.props.children
        )
      );
    }
  }]);
  return D3ReactForce;
}(_react2.default.Component), _class.defaultProps = {
  nodes: [],
  links: [],
  width: _default.WIDTH,
  height: _default.HEIGHT,
  nodeIdKey: _default.NODE_ID_KEY,
  velocityDecay: _default.VELOCITY_DECAY,
  linkDistance: _default.LINK_DISTANCE,
  collideRadius: _default.COLLIDE_RADIUS,
  collideStrength: _default.COLLIDE_STRENGTH,
  chargeStrength: _default.CHARGE_STRENGTH,
  staticLayout: false,
  XYCenter: _default.XY_CENTER,
  nodeClick: _default.noop,
  nodeDbClick: _default.noop,
  nodeMouseover: _default.noop,
  nodeMouseout: _default.noop,
  linkClick: _default.noop,
  linkMouseover: _default.noop,
  linkMouseout: _default.noop,
  tick: _default.noop,
  end: _default.noop
}, _initialiseProps = function _initialiseProps() {
  var _this4 = this;

  this.tick = function (alpha) {
    var _props3 = _this4.props,
        nodeIdKey = _props3.nodeIdKey,
        tick = _props3.tick,
        staticLayout = _props3.staticLayout,
        end = _props3.end;
    var force = _this4.force;
    var _force2 = _this4.force,
        nodes = _force2.nodes,
        links = _force2.links;

    if (tick) {
      tick(alpha, {
        nodes: nodes,
        links: links,
        nodesDom: _this4.nodesDom,
        linksDom: _this4.linksDom
      });
    }
    if (!staticLayout) {
      nodes.forEach(function (node) {
        d3.select(_this4.nodesDom[node[nodeIdKey]]).attr('transform', function () {
          return 'translate(' + node.x + ',' + node.y + ')';
        });
      });
      links.forEach(function (link) {
        d3.select(_this4.linksDom[link.source[nodeIdKey] + '_' + link.target[nodeIdKey]]).attr('x1', function () {
          return force.nodesMap[link.source[nodeIdKey]].x;
        }).attr('y1', function () {
          return force.nodesMap[link.source[nodeIdKey]].y;
        }).attr('x2', function () {
          return force.nodesMap[link.target[nodeIdKey]].x;
        }).attr('y2', function () {
          return force.nodesMap[link.target[nodeIdKey]].y;
        });

        d3.select(_this4.hoverLinksDom[link.source[nodeIdKey] + '_' + link.target[nodeIdKey]]).attr('x1', function () {
          return force.nodesMap[link.source[nodeIdKey]].x;
        }).attr('y1', function () {
          return force.nodesMap[link.source[nodeIdKey]].y;
        }).attr('x2', function () {
          return force.nodesMap[link.target[nodeIdKey]].x;
        }).attr('y2', function () {
          return force.nodesMap[link.target[nodeIdKey]].y;
        });
      });
    }
  };

  this.zoomTo = function (transform) {
    _this4.force.zoom.transform(d3.select(_this4.svg), d3.zoomIdentity.translate(transform.translate[0], transform.translate[1]).scale(transform.scale));
  };

  this.free = function () {
    _this4.force.nodes.forEach(function (node) {
      node.fx = node.fy = null;
    });
    _this4.force.simulation.alpha(1).restart();
  };

  this.addLayout = function (layout) {
    var _options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var _Layout = _layout3.default[layout];
    if (_Layout) {
      var _props4 = _this4.props,
          width = _props4.width,
          height = _props4.height;

      var options = (0, _assign2.default)({ width: width, height: height }, _options);
      _this4[layout + 'Layout'] = new _Layout(options, _this4.force);
      return {
        execute: _this4.executeLayout.bind(_this4, layout)
      };
    } else {
      throw new Error('Can not find the layout of ' + layout);
    }
  };

  this.executeLayout = function (layout) {
    var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var _layout = _this4[layout + 'Layout'];
    if (_layout) {
      _this4.forceEndTick();
      setTimeout(function () {
        // 解决tick直接更新dom的x、y问题
        _layout.execute(event);
        _this4.transformPosition();
        _this4.adaption(true);
      }, 100);
    }
  };

  this.adaption = function () {
    var animation = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    var padding = 20;
    var _props5 = _this4.props,
        width = _props5.width,
        height = _props5.height;
    var nodes = _this4.force.nodes;

    var minX = 0,
        minY = 0,
        maxX = 0,
        maxY = 0;
    if (nodes.length) {
      minX = _lodash2.default.minBy(nodes, 'x').x;
      minY = _lodash2.default.minBy(nodes, 'y').y;
      maxX = _lodash2.default.maxBy(nodes, 'x').x;
      maxY = _lodash2.default.maxBy(nodes, 'y').y;
    }
    var offset = {
      width: maxX - minX,
      height: maxY - minY,
      x: minX,
      y: minY
    };
    var factor = 1,
        translateX = 0,
        translateY = 0;
    if (offset.width > width || offset.height > height) {
      if (offset.width / width > offset.height / height) {
        factor = (width - padding) / offset.width;
      } else {
        factor = (height - padding) / offset.height;
      }
    }
    translateX = width / 2 - minX * factor - offset.width / 2 * factor;
    translateY = height / 2 - minY * factor - offset.height / 2 * factor;
    if (animation) {
      d3.select(_this4.outg).transition().duration(duration).attr('transform', 'translate(' + [translateX, translateY] + ')scale(' + factor + ')');
      var timer = setTimeout(function () {
        _this4.force.zoom.transform(d3.select(_this4.svg), d3.zoomIdentity.translate(translateX, translateY).scale(factor));
      }, duration);
    } else {
      _this4.force.zoom.transform(d3.select(_this4.svg), d3.zoomIdentity.translate(translateX, translateY).scale(factor));
    }
  };

  this.transform = function (translate, scale, animation) {
    if (!translate && !scale) {
      return {
        translate: _this4.force.translate,
        scale: _this4.force.scale
      };
    } else {
      if (animation) {
        d3.select(_this4.outg).transition().duration(duration).attr('transform', 'translate(' + translate + ')scale(' + scale + ')');
        setTimeout(function () {
          var _d3$zoomIdentity;

          _this4.force.zoom.transform(d3.select(_this4.svg), (_d3$zoomIdentity = d3.zoomIdentity).translate.apply(_d3$zoomIdentity, (0, _toConsumableArray3.default)(translate)).scale(scale));
        }, duration);
      } else {
        var _d3$zoomIdentity2;

        _this4.force.zoom.transform(d3.select(_this4.svg), (_d3$zoomIdentity2 = d3.zoomIdentity).translate.apply(_d3$zoomIdentity2, (0, _toConsumableArray3.default)(translate)).scale(scale));
      }
    }
  };

  this.zoom = function (_scale) {
    var _d3$zoomIdentity3;

    var _force3 = _this4.force,
        translate = _force3.translate,
        scale = _force3.scale;

    _this4.force.zoom.transform(d3.select(_this4.svg), (_d3$zoomIdentity3 = d3.zoomIdentity).translate.apply(_d3$zoomIdentity3, (0, _toConsumableArray3.default)(translate)).scale(_scale * scale));
  };

  this.transformPosition = function () {
    var force = _this4.force,
        props = _this4.props;
    var nodeIdKey = props.nodeIdKey;
    var nodes = force.nodes,
        links = force.links;

    nodes.forEach(function (node) {
      d3.select(_this4.nodesDom[node[nodeIdKey]]).transition().duration(duration).attr('transform', function () {
        return 'translate(' + node.x + ',' + node.y + ')';
      });
    });
    links.forEach(function (link) {
      d3.select(_this4.linksDom[link.source[nodeIdKey] + '_' + link.target[nodeIdKey]]).transition().duration(duration).attr('x1', function () {
        return force.nodesMap[link.source[nodeIdKey]].x;
      }).attr('y1', function () {
        return force.nodesMap[link.source[nodeIdKey]].y;
      }).attr('x2', function () {
        return force.nodesMap[link.target[nodeIdKey]].x;
      }).attr('y2', function () {
        return force.nodesMap[link.target[nodeIdKey]].y;
      });
    });
  };

  this.forceEndTick = function () {
    var alphaTarget = _this4.force.simulation.alphaTarget();
    _this4.force.simulation.alphaTarget(alphaTarget).alpha(alphaTarget);
  };

  this.getStaticLayoutTransform = function () {
    var _props6 = _this4.props,
        nodes = _props6.nodes,
        width = _props6.width,
        padding = _props6.padding;

    var nodesX = nodes.map(function (node) {
      return node.x;
    });
    var nodesY = nodes.map(function (node) {
      return node.y;
    });
    var minX = Math.min.apply(Math, (0, _toConsumableArray3.default)(nodesX)),
        minY = Math.min.apply(Math, (0, _toConsumableArray3.default)(nodesY)),
        maxX = Math.max.apply(Math, (0, _toConsumableArray3.default)(nodesX)),
        maxY = Math.max.apply(Math, (0, _toConsumableArray3.default)(nodesY));
    var graphWidth = maxX - minX,
        graphHeight = maxY - minY;
    var scale = width > graphWidth ? 1 : width / graphWidth;
    var translateX = scale * minX,
        translateY = scale * minY;
    return {
      width: graphWidth * scale + 2 * padding,
      height: graphHeight * scale + 2 * padding,
      translate: [-translateX + padding, -translateY + padding],
      scale: scale,
      graphWidth: graphWidth,
      graphHeight: graphHeight
    };
  };
}, _temp);


D3ReactForce.Simulation = _simulation2.default;
D3ReactForce.Node = _node2.default;
D3ReactForce.Link = _link2.default;
exports.default = D3ReactForce;
//# sourceMappingURL=index.js.map