'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ArchimeddeanSpiral = function (_Base) {
  (0, _inherits3.default)(ArchimeddeanSpiral, _Base);

  function ArchimeddeanSpiral(options, simulation) {
    (0, _classCallCheck3.default)(this, ArchimeddeanSpiral);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ArchimeddeanSpiral.__proto__ || (0, _getPrototypeOf2.default)(ArchimeddeanSpiral)).call(this, options, simulation));

    (0, _assign2.default)(_this, {
      /**
       * 宽
       * @type  {number}
       */
      width: null,

      /**
       * 高
       * @type  {number}
       */
      height: null,

      /**
       * 图中心
       * @type  {object}
       */
      center: null,

      /**
       * 参数 a
       * @type  {number}
       */
      a: 20,

      /**
       * 参数 b
       * @type  {number}
       */
      b: 15,

      /**
       * 最大角度
       * @type  {number}
       */
      maxAngle: 12 * Math.PI
    }, options);
    return _this;
  }
  // 执行布局


  (0, _createClass3.default)(ArchimeddeanSpiral, [{
    key: 'execute',
    value: function execute(_ref) {
      var _ref$beforeExecute = _ref.beforeExecute,
          beforeExecute = _ref$beforeExecute === undefined ? function () {} : _ref$beforeExecute;
      var nodes = this.simulation.nodes;
      var a = this.a,
          b = this.b,
          maxAngle = this.maxAngle;

      var width = this.width;
      var height = this.height;
      var center = this.center ? this.center : {
        x: width / 2,
        y: height / 2
      };
      var l = nodes.length;
      var angleStep = maxAngle / l;
      var getAngle = function getAngle(i) {
        return i * angleStep;
      };
      var getRadius = function getRadius(angle) {
        return a + b * angle;
      };
      this.sort && nodes.sort(this.sort);
      this.simulation.nodes = nodes;
      beforeExecute && beforeExecute(nodes);
      nodes.forEach(function (node, i) {
        var angle = getAngle(i);
        var radius = getRadius(angle);
        node.fx = node.x = center.x + radius * Math.cos(angle);
        node.fy = node.y = center.y + radius * Math.sin(angle);
      });
    }
  }]);
  return ArchimeddeanSpiral;
}(_base2.default);
/**
 * @fileOverview 阿基米德螺线布局
 * https://zh.wikipedia.org/wiki/%E9%98%BF%E5%9F%BA%E7%B1%B3%E5%BE%B7%E8%9E%BA%E7%BA%BF
 * @author can.yang@tongdun.cn
 */


exports.default = ArchimeddeanSpiral;
//# sourceMappingURL=archimeddeanSpiral.js.map